*
*	Pi.cc -- pi$@%U%)!<%^%C%H2hA|$r07$&(J
*
*		created    in 3/21/1993
*		revised    in 2/13/1994
*

*	X68 assembler version May,10,1999 by Rick

* NO_APP
RUNS_HUMAN_VERSION	equ	3
	.cpu 68000
	.include doscall.equ
* X68 GCC Develop

BUFSIZE	equ	32768

PicBitLoad1	macro

	local	pbl1_e

	dbra	d7,pbl1_e
	bsr	_PicBufferNext
	moveq.l	#15,d7
pbl1_e
	moveq.l	#0,d0
	add.w	d3,d3
	scc	d0
	addq.b	#1,d0

	endm


PicBitWrite1	macro

	local	pbw1_e

	tst.w	BITLENGTH(a6)
	bne	pbw1_e
	bsr	_PicWriteBufferNext
pbw1_e
	subq.w	#1,BITLENGTH(a6)
	movea.l	BITBUFFERPOINTER(a6),a0
	move.l	(a0),d0
	add.l	d0,d0
	add.b	d1,d0
	move.l	d0,(a0)

	endm


Search	macro

	local	nomatch,low,s_lp,s_brk,s_end

	move.b	(a1),d1
	lea	(a1,d0.l),a0
	cmp.b	(a0),d1
	beq	nomatch
	moveq.l	#0,d0
	bra	s_end
nomatch
	move.l	RESTLENGTH(a6),a2
	add.l	a2,a2
	move.w	#30000,d2
	cmp.l	d2,a2
	bge	low
	move.l	a2,d2
low
	sub.l	d2,a2
	subq.w	#1,d2
s_lp
	move.b	(a0)+,d1
	cmp.b	(a1)+,d1
	dbne	d2,s_lp
s_brk
	addq.w	#1,d2
	lea	1(a2,d2.l),a0
	move.l	a0,d0
	asr.l	#1,d0
	sub.l	RESTLENGTH(a6),d0
	neg.l	d0
s_end
	endm

	.offset -10

FILEHANDLE		.ds.w	1
BITBUFFER		.ds.l	1
BITBUFFERLENGTH		.ds.l	1
BITLENGTH		.ds.w	1
BITBUFFERPOINTER	.ds.l	1
IND1			.ds.l	1
IND2			.ds.l	1
IND3			.ds.l	1
IND4			.ds.l	1
PIPLANESIZE		.ds.l	1
PIYRATIO		.ds.l	1
PIXRATIO		.ds.l	1
PIMODE			.ds.l	1
SCREEN2			.ds.l	1
RESTLENGTH		.ds.l	1
PREVIOUSCOLOR		.ds.l	1
COLORTABLE256		.ds.l	1
COLORTABLE		.ds.b	290

	.even
	.text
?C0:
	.dc.b 'Error in writing',$00

?C3:
	.dc.b 'No such file',$00
?C4:
	.dc.b 'Insufficient memory',$00
?C5:
	.dc.b 'Is not pi format',$00
?C6:
	.dc.b 'Unknown pi-mode',$00
?C7:
	.dc.b 'Irregal place size',$00
?C8:
	.dc.b 'Insufficient memory',$00

	.even
	.globl _PiLoad
_PiLoad:
	movem.l	d3/d4/d5/d6/d7/a3/a4/a5/a6,-(sp)
	lea.l	_BitBuf+10,a6
	move.l	#BUFSIZE,-(sp)
	DOS	_di_malloc
	addq.w	#4,sp
	move.l	d0,BITBUFFER(a6)
	bge	?418
	pea	?C4(OPC)
	jbsr	_error
	addq.w	#4,sp
?418:
	moveq.l	#0,d7
	move.l	d7,d5

	moveq.l	#0,d0
	tst.l	_fp
	bne	?417
	move.w	d0,-(sp)
	move.l	_File,-(sp)
	DOS	_di_open
	addq.w	#6,sp
	tst.w	d0
	bgt	?417
	pea	?C3(OPC)
	jbsr	_error
	addq.w	#4,sp
?417:
	move.w	d0,FILEHANDLE(a6)
	bsr	_PicGetc
	cmpi.b	#80,d0
	beq	?420
	pea	?C5(OPC)
	jbsr	_error
	addq.w	#4,sp
?420:
	bsr	_PicGetc
	cmpi.b	#105,d0
	beq	?421
	pea	?C5(OPC)
	jbsr	_error
	addq.w	#4,sp
?421:
	moveq.l	#0,d2
?426:
	bsr	_PicGetc
	cmpi.b	#26,d0
	beq	?423
	addq.w	#1,d2
	cmp.w	#16383,d2
	ble	?426
?423:
	cmp.w	#16384,d2
	bne	?427
	pea	?C5(OPC)
	jbsr	_error
	addq.w	#4,sp
?427:
	moveq.l	#0,d2
?432:
	bsr	_PicGetc
	tst.l	d0
	beq	?429
	addq.w	#1,d2
	cmp.w	#16383,d2
	ble	?432
?429:
	cmp.w	#16384,d2
	bne	?433
	pea	?C5(OPC)
	jbsr	_error
	addq.w	#4,sp
?433:
	bsr	_PicGetc
	move.l	d0,PIMODE(a6)
	and.w	#65407,d0
	tst.l	d0
	beq	?434
	pea	?C6(OPC)
	jbsr	_error
	addq.w	#4,sp
?434:
	lea	PIXRATIO(a6),a3
	bsr	_PicGetc
	move.l	d0,(a3)
	bsr	_PicGetc
	move.l	d0,PIYRATIO(a6)
	tst.l	(a3)
	beq	?436
	tst.l	d0
	bne	?435
?436:
	moveq.l	#1,d2
	move.l	d2,PIYRATIO(a6)
	move.l	d2,(a3)
?435:
	bsr	_PicGetc
	move.l	d0,PIPLANESIZE(a6)
	cmpi.b	#4,d0
	beq	?438
	cmpi.b	#8,d0
	beq	?437
	pea	?C7(OPC)
	jbsr	_error
	addq.w	#4,sp
?437:
	move.l	#65552,-(sp)
	DOS	_di_malloc
	addq.w	#4,sp
	bge	?441
	pea	?C8(OPC)
	jbsr	_error
	addq.w	#4,sp
?438:
	moveq.l	#0,d0
?441:
	move.l	d0,COLORTABLE256(a6)
	bsr	_PicGetc
	bsr	_PicGetc
	bsr	_PicGetc
	bsr	_PicGetc
	bsr	_PicGetc
	move.l	d0,d2
	lsl.w	#8,d2
	bsr	_PicGetc
	add.b	d0,d2
	bra	?442
?445:
	bsr	_PicGetc
?442:
	dbra	d2,?445

	lea	_Width,a5
	bsr	_PicGetc
	lsl.w	#8,d0
	move.l	d0,(a5)
	bsr	_PicGetc
	add.l	d0,(a5)
	lea	_Height,a5
	bsr	_PicGetc
	lsl.w	#8,d0
	move.l	d0,(a5)
	bsr	_PicGetc
	add.l	d0,(a5)
	move.l	_Screen,d0
	beq	?446
	move.l	d0,-(sp)
	DOS	_di_mfree
	addq.w	#4,sp
?446:
	move.l	a2,-(sp)
	lea	_Screen,a3
	lea	_Size,a4
	move.l	_Width,d0
	lea	___mulsi3,a5
	move.l	_Height,-(sp)
	move.l	d0,-(sp)
	jbsr	(a5)
	addq.w	#8,sp
	move.l	PIXRATIO(a6),-(sp)
	move.l	d0,-(sp)
	jbsr	(a5)
	addq.w	#8,sp
	move.l	PIYRATIO(a6),-(sp)
	move.l	d0,-(sp)
	jbsr	(a5)
	addq.w	#8,sp
	move.l	(sp)+,a2
	add.l	d0,d0
	move.l	d0,(a4)
	move.l	d0,a0
	pea	64(a0)
	DOS	_di_malloc
	addq.w	#4,sp
	move.l	d0,(a3)
	bge	?448
	pea	?C8(OPC)
	jbsr	_error
	addq.w	#4,sp
?448:
	move.l	_Width,d0
	move.l	_Height,d2
	addq.l	#2,d2
	mulu	d2,d0
	move.l	d0,a0
	pea	64(a0)
	DOS	_di_malloc
	addq.w	#4,sp
	move.l	d0,SCREEN2(a6)
	bge	?450
	pea	?C8(OPC)
	jbsr	_error
	addq.w	#4,sp
?450:
*	moveq.l	#0,d3
*	lea	_Width,a3
*	bra	?452
*?455:
*	move.l	SCREEN2(a6),a0
*	add.l	d3,a0
*	clr.b	(a0)
*	addq.l	#1,d3
*?452:
*	move.l	(a3),d0
*	move.l	_Height,d2
*	addq.l	#2,d2
*	move.l	d2,-(sp)
*	move.l	d0,-(sp)
*	jbsr	___mulsi3
*	addq.w	#8,sp
*	cmp.l	d3,d0
*	bgt	?455

	tst.b	PIMODE+3(a6)
	bge	?456
	moveq.l	#4,d2
	cmp.l	PIPLANESIZE(a6),d2
	bne	?457
	moveq.l	#0,d1		*i
	move.l	d1,d2
	lea	_Red,a5
	lea	_Green,a4
	lea	_Blue,a3
?470:
	moveq.l	#0,d0
	btst	#1,d1
	sne	d0
	addq.b	#1,d0
	cmpi.w	#7,d1
	ble	@f
	add.w	d0,d0
@@
	lsl.w	#7,d0
	subq.w	#1,d0
	move.w	d0,(a5,d2.l)	*Red[i]
	moveq.l	#0,d0
	btst	#2,d1
	sne	d0
	addq.b	#1,d0
	cmpi.w	#7,d1
	ble	@f
	add.w	d0,d0
@@
	lsl.w	#7,d0
	subq.w	#1,d0
	move.w	d0,(a4,d2.l)	*Green[i]
	moveq.l	#0,d0
	btst	#0,d1
	sne	d0
	addq.b	#1,d0
	cmpi.w	#7,d1
	ble	@f
	add.w	d0,d0
@@
	lsl.w	#7,d0
	subq.w	#1,d0
	move.w	d0,(a3,d2.l)	*Blue[i]
	addq.l	#2,d2
	addq.l	#1,d1
	cmpi.w	#15,d1
	ble	?470
	bra	?476
?457:
	moveq.l	#0,d1
	lea	_Blue,a3
	lea	_Green,a1
	lea	_Red,a0
?475:
	move.l	d1,d0
	andi.w	#$1c,d0
	lsl.w	#3,d0
	move.w	d0,(a0)+
	move.l	d1,d0
	andi.w	#$e0,d0
	move.w	d0,(a1)+
	moveq.l	#3,d0
	and.w	d1,d0
	ror.b	#2,d0
	move.w	d0,(a3)+
	addq.l	#1,d1
	cmpi.w	#255,d1
	ble	?475
	bra	?476
?456:
	moveq.l	#1,d2
	move.l	PIPLANESIZE(a6),d0
	asl.l	d0,d2
	lea	_Red,a4
	lea	_Green,a3
	lea	_Blue,a1
	bra	?477
?480:
	bsr	_PicGetc
	move.w	d0,(a4)+
	bsr	_PicGetc
	move.w	d0,(a3)+
	bsr	_PicGetc
	move.w	d0,(a1)+
?477:
	dbra	d2,?480
?476:
	bsr	_ColorTableInitialize
	bsr	_ExpandPi
	move.l	_Width,d2
	move.l	_Height,d0
	mulu	d2,d0
	movea.l	_Screen,a4
	movea.l	SCREEN2(a6),a5
	add.l	d2,d2
	add.l	d2,a5
	moveq.l	#0,d1
	bra	?481
?484:
	move.b	(a5)+,d1
	move.w	d1,(a4)+
?481:
	dbra	d0,?484
	clr.w	d0
	subq.l	#1,d0
	bpl	?484

	moveq.l	#1,d2
	cmp.l	PIXRATIO(a6),d2
	bne	?486
	cmp.l	PIYRATIO(a6),d2
	beq	?485
?486:
	lea	_Width,a4
	move.l	(a4),d7
	lea	___mulsi3,a3
	move.l	PIYRATIO(a6),-(sp)
	move.l	d7,-(sp)
	jbsr	(a3)
	addq.w	#8,sp
	move.l	d0,(a4)
	lea	_Height,a4
	move.l	(a4),d0
	move.l	PIXRATIO(a6),-(sp)
	move.l	d0,-(sp)
	jbsr	(a3)
	addq.w	#8,sp
	move.l	d0,(a4)
	move.l	d0,d6
	bra	?502
?494:
	move.l	_Width,d5
	bra	?503
?493:
	lea	___mulsi3,a3
	move.l	_Width,-(sp)
	move.l	d6,-(sp)
	jbsr	(a3)
	addq.w	#8,sp
	move.l	d0,d3
	add.l	d5,d3
	move.l	_Screen,a4
	add.l 	3,d3
	lea	___divsi3,a5
	move.l	PIYRATIO(a6),-(sp)
	move.l	d5,-(sp)
	jbsr	(a5)
	addq.w	#8,sp
	move.l	d0,d4
	move.l	PIXRATIO(a6),-(sp)
	move.l	d6,-(sp)
	jbsr	(a5)
	addq.w	#8,sp
	move.l	d7,-(sp)
	move.l	d0,-(sp)
	jbsr	(a3)
	addq.w	#8,sp
	add.l	d0,d4
	move.l	_Screen,a0
	add.l	d4,d4
	move.w	(a0,d4.l),(a4,d3.l)
?503:
	subq.l	#1,d5
	bpl	?493
?502:
	subq.l	#1,d6
	bpl	?494
?485:
	moveq.l	#8,d2
	cmp.l	PIPLANESIZE(a6),d2
	bne	?495
	move.l	COLORTABLE256(a6),-(sp)
	DOS	_di_mfree
	addq.w	#4,sp
?495:
	move.l	SCREEN2(a6),-(sp)
	DOS	_di_mfree
	addq.w	#4,sp
	move.w	FILEHANDLE(a6),d0
	beq	?499
	move.w	d0,-(sp)
	DOS	_di_close
	addq.w	#2,sp
?499:
	move.l	BITBUFFER(a6),-(sp)
	DOS	_di_mfree
	addq.w	#4,sp

	moveq.l	#4,d2
	cmp.l	PIPLANESIZE(a6),d2
	bne	?500
	moveq.l	#16,d2
	move.l	d2,_MaxColorGuaranteed
	bra	?501
?500:
	move.l	#256,_MaxColorGuaranteed
?501:
	movem.l	(sp)+,d3/d4/d5/d6/d7/a3/a4/a5/a6
	rts

	.even
	.globl _PiSave
_PiSave:
	movem.l	d3/d4/a3/a4/a5/a6,-(sp)
	lea.l	_BitBuf+10,a6
	move.l	_Screen,a4
	move.l	_Size,d4
	lsr.l	#1,d4
	move.l	_Width,d2
	move.l	_Height,d0
	addq.l	#2,d0
	mulu	d2,d0
	move.l	d0,a0
	pea	16(a0)
	DOS	_di_malloc
	addq.w	#4,sp
	move.l	d0,SCREEN2(a6)
	bge	?506
	pea	?C8(OPC)
	jbsr	_error
	addq.w	#4,sp
?506:
	move.l	d4,d3
	move.l	d0,a0
	add.l	d2,d2
	adda.l	d2,a0
	bra	?508
?511:
	move.b	(a4)+,(a0)+
?508:
	dbra	d3,?511
	clr.w	d3
	subq.l	#1,d3
	bpl	?511

	move.l	#BUFSIZE,-(sp)
	DOS	_di_malloc
	addq.w	#4,sp
	move.l	d0,BITBUFFERPOINTER(a6)
	move.l	d0,BITBUFFER(a6)
	bge	?513
	pea	?C4(OPC)
	jbsr	_error
	addq.w	#4,sp
?513:
	move.l	#BUFSIZE,BITBUFFERLENGTH(a6)
	moveq.l	#32,d2
	move.w	d2,BITLENGTH(a6)

	moveq.l	#1,d0
	tst.l	_fp
	bne	?512
	move.w	#$20,-(sp)
	move.l	_File,-(sp)
	DOS	_di_create
	addq.w	#6,sp
	tst.w	d0
	bpl	?512
	pea	?C3(OPC)
	jbsr	_error
	addq.w	#4,sp
?512:
	move.w	d0,FILEHANDLE(a6)
	moveq.l	#16,d2
	cmp.l	_MaxColorGuaranteed,d2
	blt	?515
	moveq.l	#0,d2
	move.l	d2,COLORTABLE256(a6)
	moveq.l	#4,d2
	bra	?534
?515:
	lea	COLORTABLE256(a6),a3
	move.l	#65552,-(sp)
	DOS	_di_malloc
	addq.w	#4,sp
	move.l	d0,(a3)
	bge	?517
	pea	?C8(OPC)
	jbsr	_error
	addq.w	#4,sp
?517:
	moveq.l	#8,d2
?534:
	move.l	d2,PIPLANESIZE(a6)
	bsr	_ColorTableInitialize
	moveq.l	#80,d1
	bsr	_PicPutc
	moveq.l	#105,d1
	bsr	_PicPutc
	moveq.l	#26,d1
	bsr	_PicPutc
	moveq.l	#0,d1
	bsr	_PicPutc
	moveq.l	#0,d1
	bsr	_PicPutc
	moveq.l	#0,d1
	bsr	_PicPutc
	moveq.l	#0,d1
	bsr	_PicPutc
	move.l	PIPLANESIZE(a6),d1
	bsr	_PicPutc
	moveq.l	#45,d1
	bsr	_PicPutc
	moveq.l	#45,d1
	bsr	_PicPutc
	moveq.l	#45,d1
	bsr	_PicPutc
	moveq.l	#45,d1
	bsr	_PicPutc
	moveq.l	#0,d1
	bsr	_PicPutc
	moveq.l	#0,d1
	bsr	_PicPutc
	lea	_Width,a5
	move.l	(a5),d1
	asr.l	#8,d1
	bsr	_PicPutc
	move.l	(a5),d1
	bsr	_PicPutc
	lea	_Height,a5
	move.l	(a5),d1
	asr.l	#8,d1
	bsr	_PicPutc
	move.l	(a5),d1
	bsr	_PicPutc
	moveq.l	#0,d4
	moveq.l	#16,d2
	cmp.l	_MaxColorGuaranteed,d2
	blt	?519
	moveq.l #15,d2
	bra	?523
?519:
	move.w	#255,d2
?523:
	lea	_Red,a0
	move.w	(a0,d4.l),d1
	bsr	_PicPutc
	lea	_Green,a0
	move.w	(a0,d4.l),d1
	bsr	_PicPutc
	lea	_Blue,a0
	move.w	(a0,d4.l),d1
	bsr	_PicPutc
	addq.l	#2,d4
	dbra	d2,?523
	bra	?524
?524:
	bsr	_CompressPi
	bsr	_PicBufferWriteFlush
	moveq.l	#8,d2
	cmp.l	PIPLANESIZE(a6),d2
	bne	?529
	move.l	COLORTABLE256(a6),-(sp)
	DOS	_di_mfree
	addq.w	#4,sp
?529:
	move.l	SCREEN2(a6),-(sp)
	DOS	_di_mfree
	addq.w	#4,sp
	move.w	FILEHANDLE(a6),d0
	cmpi.w	#1,d0
	beq	?533
	move.w	d0,-(sp)
	DOS	_di_close
	addq.w	#2,sp
?533:
	move.l	BITBUFFER(a6),-(sp)
	DOS	_di_mfree
	addq.w	#4,sp
	movem.l	(sp)+,d3/d4/a3/a4/a5/a6
	rts

	.even
_ColorTableInitialize:
	move.l	d3,-(sp)
	move.l	PIPLANESIZE(a6),d0
	cmpi.b	#4,d0
	bne	?536
	moveq.l	#0,d2
	lea.l	COLORTABLE(a6),a0
	moveq.l	#15,d4
?544:
	moveq.l	#0,d1
	move.b	d2,d3
	add.b	#16,d3
?543:
	move.b	d3,d0
	sub.b	d1,d0
	and.b	#15,d0
	move.b	d0,(a0)+
	addq.w	#1,d1
	cmp.w	d1,d4
	bge	?543

	addq.w	#1,a0
	addq.w	#1,d2
	cmp.w	d2,d4
	bge	?544

	bra	?545
?536:
	moveq.l	#0,d2
	movea.l	COLORTABLE256(a6),a0
?553:
	moveq.l	#0,d1
?552:
	move.b	d2,d0
	sub.b	d1,d0
	move.b	d0,(a0)+

	addq.b	#1,d1
	bcc	?552

	addq.b	#1,d2
	bcc	?553
?545:
	move.l	(sp)+,d3
	rts

	.even
_ExpandPi:
	move.l	_Width,d0
	move.l	d0,IND1(a6)
	move.l	d0,d1
	add.l	d0,d0
	move.l	d0,IND2(a6)
	subq.l	#1,d1
	move.l	d1,IND3(a6)
	addq.l	#2,d1
	move.l	d1,IND4(a6)

	moveq.l	#4,d0
	cmp.l	PIPLANESIZE(a6),d0
	bne	?555
	lea	_PiReadColor16(OPC),a5
	bra	?556
?555:
	lea	_PiReadColor256(OPC),a5
?556:
	moveq.l	#0,d0
	move.l	d0,PREVIOUSCOLOR(a6)
	jbsr	(a5)
	move.b	d0,d4
	jbsr	(a5)
	move.b	d0,d2
	move.l	SCREEN2(a6),a3
	move.l	_Width,d1
	move.w	d1,d0
	bra	?557
?560:
	move.b	d4,(a3)+
	move.b	d2,(a3)+
?557:
	dbra	d0,?560
	move.l	_Height,d0
	mulu	d1,d0
	move.l	d0,d6
	lsr.l	#1,d6
	move.w	#-1,a4
?562:
	moveq.l	#2,d2
	bsr	_PicBitLoad
	move.w	d0,d5
	cmpi.w	#3,d5
	bne	?565
	PicBitLoad1
	add.b	d0,d5
?565:
	cmp.w	a4,d5
	bne	?566
	move.w	#-1,a4
	moveq.l	#0,d0
	move.b	-1(a3),d0
	move.l	d0,PREVIOUSCOLOR(a6)
?567:
	jbsr	(a5)
	move.b	d0,(a3)+
	jbsr	(a5)
	move.b	d0,(a3)+
	subq.l	#1,d6
	PicBitLoad1
	bne	?567

	bra	?562
?566:
	move.w	d5,a4

*PiReadLength
	PicBitLoad1
	bne	?597
	moveq.l	#1,d1
	bra	?596
?597:
	moveq.l	#1,d4
?598:
	PicBitLoad1
	beq	?599
	addq.l	#1,d4
	bra	?598
?599:
	move.l	d4,d2
	bsr	_PicBitLoad
	moveq.l	#1,d1
	asl.l	d4,d1
	add.l	d0,d1
?596:
	ble	?562
	sub.l	d1,d6
	bpl	?572
	add.l	d6,d1
	moveq.l	#0,d6
?572:
	swap.w	d3
	dbra	d5,?581

	lea	-4(a3),a0
	move.b	(a0)+,d5
	move.b	(a0)+,d4
	move.b	(a0)+,d2
	move.b	(a0)+,d3
	move.l	d1,d0
	add.l	d1,d0
	add.l	d0,a3
	cmp.b	d3,d2
	bne	?582
	move.b	d3,d4
	move.b	d2,d5
?582:
	cmpi.l	#1,d1
	bne	?583
	move.b	d5,(a0)+
	move.b	d4,(a0)
	bra	?573
?583:
	addq.l	#1,d1
	move.l	d1,d0
	asr.l	#1,d1
?585:
	cmp.l	#16000,d1
	ble	?588
	move.l	#16000,d0
	bra	?589
?588:
	move.l	d1,d0
?589:
	sub.l	d0,d1
?590:
	move.b	d5,(a0)+
	move.b	d4,(a0)+
	move.b	d2,(a0)+
	move.b	d3,(a0)+
	dbra	d0,?590
	clr.w	d0
	subq.l	#1,d0
	bgt	?590

	tst.l	d1
	bne	?585
	bra	?573
?581:
	add.w	d5,d5
	add.w	d5,d5
	move.l	a3,a1
	sub.l	IND1(a6,d5.w),a1
	movea.l	a3,a0
	move.l	d1,d0
	bra	?578
?580:
	move.b	(a1)+,(a0)+
	move.b	(a1)+,(a0)+
?578:
	dbra	d0,?580
	clr.w	d0
	subq.l	#1,d0
	bpl	?580

	movea.l	a0,a3
?573:
	swap.w	d3
	tst.l	d6
	bgt	?562
	rts

	.even
_PicGetc:
	tst.w	d7
	bne	exist_g
	bsr	_PicBufferNext
exist_g:
	subq.w	#8,d7
	rol.w	#8,d3
	moveq.l	#0,d0
	move.b	d3,d0
	rts

?C1:
	.dc.b 'Unexpected EOF',$00
	.even
_PicBufferNext:
	swap.w	d5
	subq.w	#2,d5
	bge	?380
	move.l	#BUFSIZE,-(sp)
	move.l	BITBUFFER(a6),-(sp)
	move.w	FILEHANDLE(a6),-(sp)
	DOS	_di_read
	lea	10(sp),sp
	tst.l	d0
	bgt	@f
	pea	?C1(OPC)
	jbsr	_error
	addq.w	#4,sp
@@
	move.w	d0,d5
	subq.w	#2,d5
	movea.l	BITBUFFER(a6),a2
?380:
	move.w	(a2)+,d3
	moveq.l	#16,d7
	swap.w	d5
	rts

	.even
_PicBitLoad:
	moveq.l	#0,d1
	bra	?400
?407:
	sub.w	d7,d2
	bra	?402
?406
	add.l	d1,d1
	add.w	d3,d3
	bcc	?402
	addq.b	#1,d1
?402:
	dbra	d7,?406
	bsr	_PicBufferNext
?400:
	cmp.w	d7,d2
	bgt	?407

	sub.w	d2,d7
	bra	?408
?412:
	add.l	d1,d1
	add.w	d3,d3
	bcc	?408
	addq.b	#1,d1
?408:
	dbra	d2,?412
	move.l	d1,d0
	rts

	.even

	.even
_PiReadColor16:
	PicBitLoad1
	beq	?603
	PicBitLoad1
	move.l	d0,d2
	bra	?604
?603:
	PicBitLoad1
	bne	?605
	PicBitLoad1
	move.l	d0,d2
	addq.w	#2,d2
	bra	?604
?605:
	PicBitLoad1
	bne	?606
	moveq.l	#2,d2
	bsr	_PicBitLoad
	move.l	d0,d2
	addq.w	#4,d2
	bra	?604
?606:
	moveq.l	#3,d2
	bsr	_PicBitLoad
	move.l	d0,d2
	addq.w	#8,d2
?604:
	move.l	PREVIOUSCOLOR(a6),d1
	move.l	d1,d0
	asl.l	#4,d0
	add.l	d1,d0
	lea	COLORTABLE(a6),a1
	add.l	d0,a1
	move.l	a1,d1
	lea	(a1,d2.l),a0
	moveq.l	#0,d0
	move.b	(a0),d0
	tst.l	d2
	beq	?607
	lea	1(a0),a1
	bra	?608
?610:
	move.b	-(a0),-(a1)
?608:
	dbra	d2,?610
	move.l	d1,a1
	move.b	d0,(a1)
?607:
	move.l	d0,PREVIOUSCOLOR(a6)
	rts

	.even
_PiReadColor256:
	PicBitLoad1
	beq	?613
	PicBitLoad1
	move.l	d0,d1
	bra	?614
?613:
	PicBitLoad1
	bne	?615
	PicBitLoad1
	move.l	d0,d1
	addq.w	#2,d1
	bra	?614
?615:
	PicBitLoad1
	bne	?616
	moveq.l	#2,d2
	bsr	_PicBitLoad
	move.l	d0,d1
	addq.w	#4,d1
	bra	?614
?616:
	PicBitLoad1
	bne	?617
	moveq.l	#3,d2
	bsr	_PicBitLoad
	move.l	d0,d1
	addq.w	#8,d1
	bra	?614
?617:
	PicBitLoad1
	bne	?618
	moveq.l	#4,d2
	bsr	_PicBitLoad
	moveq.l	#16,d1
	add.b	d0,d1
	bra	?614
?618:
	PicBitLoad1
	bne	?619
	moveq.l	#5,d2
	bsr	_PicBitLoad
	moveq.l	#32,d1
	add.b	d0,d1
	bra	?614
?619:
	PicBitLoad1
	bne	?620
	moveq.l	#6,d2
	bsr	_PicBitLoad
	moveq.l	#64,d1
	add.b	d0,d1
	bra	?614
?620:
	moveq.l	#7,d2
	bsr	_PicBitLoad
	move.l	d0,d1
	tas	d1
?614:
	move.l	PREVIOUSCOLOR(a6),d0
	asl.l	#8,d0
	move.l	COLORTABLE256(a6),a1
	add.l	d0,a1
	move.l	a1,d2
	lea	(a1,d1.l),a0
	moveq.l	#0,d0
	move.b	(a0),d0
	tst.l	d1
	beq	?621
	lea	1(a0),a1
	bra	?622
?624:
	move.b	-(a0),-(a1)
?622:
	dbra	d1,?624
	move.l	d2,a1
	move.b	d0,(a1)
?621:
	move.l	d0,PREVIOUSCOLOR(a6)
	rts

	.even
_PicPutc:
	tst.w	BITLENGTH(a6)
	bne	exist_p
	bsr	_PicWriteBufferNext
exist_p:
	subq.w	#8,BITLENGTH(a6)
	movea.l	BITBUFFERPOINTER(a6),a0
	move.l	(a0),d0
	rol.l	#8,d0
	move.b	d1,d0
	move.l	d0,(a0)
	rts

	.even
_PicWriteBufferNext:
	subq.l	#4,BITBUFFERLENGTH(a6)
	bgt	?372
	move.l	#BUFSIZE,-(sp)
	move.l	BITBUFFER(a6),-(sp)
	move.w	FILEHANDLE(a6),-(sp)
	DOS	_di_write
	lea	10(sp),sp
	cmp.l	#BUFSIZE,d0
	beq	?373
	pea	?C0(OPC)
	jbsr	_error
	addq.w	#4,sp
?373:
	move.l	BITBUFFER(a6),BITBUFFERPOINTER(a6)
	move.l	#BUFSIZE,BITBUFFERLENGTH(a6)
	bra	?374
?372:
	addq.l	#4,BITBUFFERPOINTER(a6)
?374:
	moveq.l	#32,d0
	move.w	d0,BITLENGTH(a6)
	rts

	.even
mask:
	.dc.l	$00000000
	.dc.l	$00000001,$00000003,$00000007,$0000000f
	.dc.l	$0000001f,$0000003f,$0000007f,$000000ff
	.dc.l	$000001ff,$000003ff,$000007ff,$00000fff
	.dc.l	$00001fff,$00003fff,$00007fff,$0000ffff
	.dc.l	$0001ffff,$0003ffff,$0007ffff,$000fffff
	.dc.l	$001fffff,$003fffff,$007fffff,$00ffffff
	.dc.l	$01ffffff,$03ffffff,$07ffffff,$0fffffff
	.dc.l	$1fffffff,$3fffffff,$7fffffff,$ffffffff

	.even
PicBitWrite:
	move.w	BITLENGTH(a6),d0
	beq	pbw_empty

	cmp.w	d0,d2
	bgt	@f
	move.w	d2,d0
	sub.w	d0,BITLENGTH(a6)
@@
	sub.w	d0,d2
	movea.l	BITBUFFERPOINTER(a6),a0
	rol.l	d0,d1
	movem.l	d1/d3,-(sp)
	move.l	(a0),d3
	lsl.l	d0,d3
	add.w	d0,d0
	add.w	d0,d0
	lea.l	mask(OPC),a1
	and.l	(a1,d0.w),d1
	or.l	d1,d3
	move.l	d3,(a0)
	movem.l	(sp)+,d1/d3

	tst.w	d2
	bgt	pbw_empty
	rts
pbw_empty:
	bsr	_PicWriteBufferNext
	movea.l	BITBUFFERPOINTER(a6),a0
	rol.l	d2,d1
	move.l	d1,(a0)
	sub.w	d2,BITLENGTH(a6)
	rts

	.even
_PiWriteColor16:
	move.l	d4,-(sp)
	move.l	d2,d0
	lsl.w	#4,d0
	add.w	d2,d0
	lea	COLORTABLE(a6),a0
	add.l	d0,a0
	movea.l	a0,a1
	move.b	(a0)+,d0
	moveq.l	#0,d4
	bra	?627
?629:
	addq.w	#1,d4
	cmpi.b	#15,d4
	bge	?628
	move.b	(a0),d2
	move.b	d0,(a0)+
	move.b	d2,d0
?627:
	cmp.b	d0,d1
	bne	?629
?628:
	move.b	d1,(a1)
	cmpi.b	#1,d4
	bgt	?630
	moveq.l	#1,d1
	PicBitWrite1
	move.l	d4,d1
	PicBitWrite1
	move.l	(sp)+,d4
	rts
?630:
	cmpi.b	#3,d4
	bgt	?632
	moveq.l	#0,d1
	moveq.l	#2,d2
	bsr	PicBitWrite
	move.l	d4,d1
	subq.l	#2,d1
	PicBitWrite1
	move.l	(sp)+,d4
	rts
?632:
	cmpi.b	#7,d4
	bgt	?634
	move.l	#%0100_0000_0000_0000_0000_0000_0000_0000,d1
*	moveq.l	#2,d1
	moveq.l	#3,d2
	bsr	PicBitWrite
	move.l	d4,d1
	subq.l	#4,d1
	moveq.l	#2,d2
	ror.l	d2,d1
	bsr	PicBitWrite
	move.l	(sp)+,d4
	rts
?634:
	move.l	#%0110_0000_0000_0000_0000_0000_0000_0000,d1
*	moveq.l	#3,d1
	moveq.l	#3,d2
	bsr	PicBitWrite
	move.l	d4,d1
	subq.l	#8,d1
	moveq.l	#3,d2
	ror.l	d2,d1
	bsr	PicBitWrite
	move.l	(sp)+,d4
	rts

	.even
_PiWriteColor256:
	move.l	d4,-(sp)
	lsl.w	#8,d2
	movea.l	COLORTABLE256(a6),a0
	adda.l	d2,a0
	movea.l	a0,a1
	move.b	(a0)+,d0
	moveq.l	#0,d4
	bra	?638
?640:
	addq.w	#1,d4
	cmp.w	#255,d4
	bge	?639
	move.b	(a0),d2
	move.b	d0,(a0)+
	move.l	d2,d0
?638:
	cmp.b	d0,d1
	bne	?640
?639:
	move.b	d1,(a1)
	cmpi.w	#1,d4
	bgt	?641
	moveq.l	#1,d1
	PicBitWrite1
	move.l	d4,d1
	PicBitWrite1
	move.l (sp)+,d4
	rts
?641:
	cmpi.w	#3,d4
	bgt	?643
	moveq.l	#0,d1
	moveq.l	#2,d2
	bsr	PicBitWrite
	move.l	d4,d1
	subq.w	#2,d1
	PicBitWrite1
	move.l (sp)+,d4
	rts
?643:
	cmpi.w	#7,d4
	bgt	?645
	move.l	#%0100_0000_0000_0000_0000_0000_0000_0000,d1
*	moveq.l	#2,d1
	moveq.l	#3,d2
	bsr	PicBitWrite
	move.l	d4,d1
	subq.w	#4,d1
	moveq.l	#2,d2
	ror.l	d2,d1
	bsr	PicBitWrite
	move.l (sp)+,d4
	rts
?645:
	cmpi.w	#15,d4
	bgt	?647
	move.l	#%0110_0000_0000_0000_0000_0000_0000_0000,d1
*	moveq.l	#6,d1
	moveq.l	#4,d2
	bsr	PicBitWrite
	move.l	d4,d1
	subq.w	#8,d1
	moveq.l	#3,d2
	ror.l	d2,d1
	bsr	PicBitWrite
	move.l (sp)+,d4
	rts
?647:
	cmpi.w	#31,d4
	bgt	?649
	move.l	#%0111_0000_0000_0000_0000_0000_0000_0000,d1
*	moveq.l	#14,d1
	moveq.l	#5,d2
	bsr	PicBitWrite
	moveq.l	#-16,d1
	add.l	d4,d1
	moveq.l	#4,d2
	ror.l	d2,d1
	bsr	PicBitWrite
	move.l (sp)+,d4
	rts
?649:
	cmpi.w	#63,d4
	bgt	?651
	move.l	#%0111_1000_0000_0000_0000_0000_0000_0000,d1
*	moveq.l	#30,d1
	moveq.l	#6,d2
	bsr	PicBitWrite
	moveq.l	#32,d1
	add.w	d4,d1
	moveq.l	#5,d2
	ror.l	d2,d1
	bsr	PicBitWrite
	move.l (sp)+,d4
	rts
?651:
	cmpi.w	#127,d4
	bgt	?653
	move.l	#%0111_1100_0000_0000_0000_0000_0000_0000,d1
*	moveq.l	#62,d1
	moveq.l	#7,d2
	bsr	PicBitWrite
	moveq.l	#-64,d1
	add.l	d4,d1
	moveq.l	#6,d2
	ror.l	d2,d1
	bsr	PicBitWrite
	move.l (sp)+,d4
	rts
?653:
	move.l	#%0111_1110_0000_0000_0000_0000_0000_0000,d1
*	moveq.l	#63,d1
	moveq.l	#7,d2
	bsr	PicBitWrite
	moveq.l	#-128,d1
	add.l	d4,d1
	moveq.l	#7,d2
	ror.l	d2,d1
	bsr	PicBitWrite
	move.l (sp)+,d4
	rts

	.even
_PiWriteLength:
	movem.l	d4/d5/d6,-(sp)
	move.l	d3,d6		*n
	moveq.l	#0,d2		*len
	moveq.l	#2,d5		*b
	addq.l	#1,d6

	.rept	30

	cmp.l	d6,d5
	bge	@f
	addq.w	#1,d2
	add.l	d5,d5

	.endm
@@
	move.l	d2,d4
	beq	?680
	addq.l	#1,d2		*len + 1
	moveq.l	#$fffffffe,d1
	ror.l	d2,d1
	bsr	PicBitWrite

	move.l	d5,d0
	bge	@f
	addq.l	#1,d0
@@
	asr.l	#1,d0
	subq.l	#1,d6
	sub.l	d0,d6
	move.l	d6,d1
	ror.l	d4,d1
	move.l	d4,d2
	bsr	PicBitWrite
	movem.l	(sp)+,d4/d5/d6
	rts
?680:
	moveq.l	#0,d1
	PicBitWrite1
	movem.l	(sp)+,d4/d5/d6
	rts

	.even
_CompressPi:
	movem.l	d3/d4/d5/d6/d7/a3/a4/a5,-(sp)
	moveq.l	#4,d2
	cmp.l	PIPLANESIZE(a6),d2
	bne	?687
	lea.l	_PiWriteColor16(OPC),a3
	bra	?688
?687:
	lea.l	_PiWriteColor256(OPC),a3
?688:
	move.l	_Width,d2
	move.l	d2,IND4(a6)
	move.l	d2,d0
	add.l	d2,d2
	move.l	d2,IND3(a6)
	movea.l	SCREEN2(a6),a5
	movea.l	a5,a1
	lea.l	(a1,d2.l),a0
	move.b	(a0)+,d1
	lsl.w	#8,d1
	move.b	(a0),d1
	bra	?689
?692:
	move.w	d1,(a1)+
?689:
	dbra	d0,?692

	move.l	IND4(a6),d0
	move.l	_Height,d1
	mulu	d1,d0
	lsr.l	#1,d0
	move.l	d0,RESTLENGTH(a6)
	move.l	a5,a4
	add.l	IND3(a6),a4
	move.b	(a4),d1
	moveq.l	#0,d2
	jbsr	(a3)
	move.l	IND3(a6),d2
	move.b	1(a5,d2.l),d1
	moveq.l	#0,d2
	move.b	(a4),d2
	jbsr	(a3)
	moveq.l	#-1,d5
?694:
	moveq.l	#0,d4
	move.l	d4,d6
	move.l	d4,IND1(a6)
	move.l	d4,d7
	move.l	d4,d3
	tst.l	d5		*Position
	beq	?697
				*calc0
	move.l	IND3(a6),d2	*Width2
	lea.l	-2(a5,d2.l),a0
	move.b	(a0)+,d0
	cmp.b	(a0),d0
	bne	?698
	moveq.l	#2,d0
	lea	-1(a0),a1
	bra	?733
?698:
	moveq.l	#4,d0
	lea	-3(a0),a1
?733:
	Search
	move.l	d0,d3
?697:
	cmpi.w	#1,d5
	beq	?700
				*calc1
	move.l	IND4(a6),d0
	lea.l	(a5,d0.l),a1
	Search
	move.l	d0,d7
?700:
	cmpi.w	#2,d5
	beq	?701
				*calc2
	move.l	IND3(a6),d0	*Width2
	movea.l	a5,a1
	Search
	move.l	d0,IND1(a6)
?701:
	cmpi.w	#3,d5
	beq	?702
	move.l	IND4(a6),d0
	subq.l	#1,d0
	lea	2(a5,d0.l),a1
	Search
	move.l	d0,d6
?702:
	cmpi.w	#4,d5
	beq	?703
	move.l	IND4(a6),d0
	addq.l	#1,d0
	lea	-2(a5,d0.l),a1
	Search
	move.l	d0,d4
?703:
	move.l	d3,d0
	add.l	d7,d0
	add.l	IND1(a6),d0
	add.l	d6,d0
	add.l	d4,d0
	bne	?704
	move.l	d5,d1
	moveq.l	#2,d2
	cmp.w	d1,d2
	bcc	?734
	addq.w	#3,d1
	addq.w	#1,d2
?734:
	ror.l	d2,d1
	bsr	PicBitWrite
?705:
	move.l	IND3(a6),d2
	lea	-2(a5,d2.l),a2
	move.l	a2,d5
	addq.w	#1,a2
	move.l	a2,IND2(a6)
	move.l	a5,a4
	add.l	d2,a4
?713:
	move.b	(a4),d1
	moveq.l	#0,d2
	move.l	IND2(a6),a2
	move.b	(a2),d2
	jbsr	(a3)
	move.b	1(a4),d1
	moveq.l	#0,d2
	move.b	(a4),d2
	jbsr	(a3)
	addq.l	#2,d5
	addq.l	#2,IND2(a6)
	addq.w	#2,a4
	addq.w	#2,a5
	lea	RESTLENGTH(a6),a0
	subq.l	#1,(a0)
	beq	?717
	move.l	d5,a2
	move.b	(a2),d2
	move.l	IND2(a6),a2
	cmp.b	(a2),d2
	bne	?718
	moveq.l	#2,d0
	move.l	d5,a1
	bra	?736
?718:
	moveq.l	#4,d0
	move.l	IND3(a6),d2
	lea	-4(a5,d2.l),a1
?736:
	Search
	move.l	d0,d3
	move.l	IND4(a6),d0
	lea.l	(a5,d0.l),a1
	Search
	move.l	d0,d7
	move.l	IND3(a6),d0
	movea.l	a5,a1
	Search
	move.l	d0,IND1(a6)
	move.l	IND4(a6),d0
	subq.l	#1,d0
	lea	2(a5,d0.l),a1
	Search
	move.l	d0,d6
	move.l	IND4(a6),d0
	addq.l	#1,d0
	lea	-2(a5,d0.l),a1
	Search
	move.l	d0,d4
	or.l	d3,d0
	or.l	d7,d0
	or.l	IND1(a6),d0
	or.l	d6,d0
	bne	@f
	moveq.l	#1,d1
	PicBitWrite1
	bra	?713
@@
	moveq.l	#0,d1
	PicBitWrite1
?704:
	moveq.l #0,d5
	cmp.l	d3,d7
	ble	?721
	move.l	d7,d3
	moveq.l	#1,d5
?721:
	cmp.l	IND1(a6),d3
	bge	?722
	move.l	IND1(a6),d3
	moveq.l	#2,d5
?722:
	cmp.l	d3,d6
	ble	?723
	move.l	d6,d3
	moveq.l	#3,d5
?723:
	cmp.l	d3,d4
	ble	?724
	move.l	d4,d3
	moveq.l	#4,d5
?724:
	move.l	d5,d1
	moveq.l	#2,d2
	cmp.w	d1,d2
	bcc	?737
	addq.w	#3,d1
	addq.w	#1,d2
?737:
	ror.l	d2,d1
	bsr	PicBitWrite
?725:
	bsr	_PiWriteLength	*arg=d3
	move.l	d3,d1
	add.l	d3,d1
	add.l	d1,a5
	lea	RESTLENGTH(a6),a0
	move.l	(a0),d0
	sub.l	d3,d0
	move.l	d0,(a0)
	bgt	?694
?717:
	moveq.l	#0,d1
	moveq.l	#32,d2
	bsr	PicBitWrite
	movem.l	(sp)+,d3/d4/d5/d6/d7/a3/a4/a5
	rts

	.even
_PicBufferWriteFlush:
	move.w	BITLENGTH(a6),d2
	cmpi.w	#32,d2
	beq	empty
	movea.l	BITBUFFERPOINTER(a6),a0
	move.l	(a0),d0
	lsl.l	d2,d0
	move.l	d0,(a0)
	lsr.w	#3,d2
	moveq.l	#4,d1
	sub.w	d2,d1
*	add.l	d1,BITBUFFERPOINTER(a6)
	sub.l	d1,BITBUFFERLENGTH(a6)
empty:
	move.l	#BUFSIZE,d1
	sub.l	BITBUFFERLENGTH(a6),d1
	ble	@f

	move.l	d1,-(sp)
	move.l	BITBUFFER(a6),-(sp)
	move.w	FILEHANDLE(a6),-(sp)
	DOS	_di_write
	lea	10(sp),sp
	cmp.l	d1,d0
	beq	@f
	pea	?C0(OPC)
	jbsr	_error
	addq.w	#4,sp
@@
	rts

	.even
	.end
