*	ColorMan.s for coerce

* NO_APP
RUNS_HUMAN_VERSION	equ	3
	.cpu 68000
	.include doscall.equ
* X68 GCC Develop
	.even

	.text

	.even
_makepalette:
	move.l	a3,-(sp)
	move.l	_MaxColorGuaranteed,d2
	lea.l	_Palette,a3
	lea.l	_Blue,a2
	lea.l	_Red,a1
	lea.l	_Green,a0
	moveq.l	#0,d0
	bra	?372
?375:
	move.w	(a0)+,d0
	lsl.w	#5,d0
	move.w	(a1)+,d1
	andi.w	#$f8,d1
	move.b	d1,d0
	add.w	d0,d0
	add.w	d0,d0
	move.w	(a2)+,d1
	andi.w	#$f8,d1
	lsr.w	#3,d1
	or.b	d1,d0
	move.w	d0,(a3)+
?372:
	dbra	d2,?375
	move.l	(sp)+,a3
	rts

	.even
_b2b:
	move.l	8(sp),d1
	movea.l	4(sp),a2
	movea.l	a2,a0
	movea.l	a0,a1
	bge	?377
	addq.l	#1,d1
?377:
	asr.l	#1,d1
	move.l	d1,d2
	bra	?378
?380:
	move.w	(a1)+,d0
	move.b	d0,(a0)+
?378:
	dbra	d1,?380
	clr.w	d1
	subq.l	#1,d1
	bpl	?380

	move.l	d2,-(sp)	*size / 2
	move.l	a2,-(sp)	*src
	DOS	_di_setblock
	addq.w	#8,sp

	rts

	.even
_b2w:
	bsr	_makepalette
	move.l	8(sp),d1
	move.l	4(sp),a1
	move.l	a1,a0
	lea.l	_Palette,a2
	asr.l	#1,d1
	bra	?383
?385:
	move.w	(a1)+,d0
	add.w	d0,d0
	move.w	(a2,d0.w),(a0)+
?383:
	dbra	d1,?385
	clr.w	d1
	subq.l	#1,d1
	bpl	?385
	rts

?C0:
	.dc.b	'Insufficient memory',$00
?C1:
	.dc.b	'over 256 colors',$00
	.even
_w2b:
	movem.l	d3/d4/d5/a3/a4/a5,-(sp)
	move.l	#65536,-(sp)
	DOS	_di_malloc
	addq.w	#4,sp
	tst.l	d0
	bpl	@f
	pea	?C0(OPC)
	bsr	_error
	addq.w	#4,sp
@@
	move.l	d0,a5		*colormap

	movea.l	28(sp),a4	*src
	move.l	32(sp),d3	*size
	moveq.l	#0,d5		*MaxColor
	movea.l	a4,a3		*rptr= wptr

	movea.l	a5,a0
	move.l	#32768/8-1,d1
	moveq.l	#-1,d0
?392:
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	dbra	d1,?392

	lsr.l	#1,d3		*size / 2
	move.l	d5,d4
	lea.l	_Red,a0
	lea.l	_Green,a1
	lea.l	_Blue,a2
	bra	?394
?402:
	move.w	(a4)+,d1	*rptr
	moveq.l	#0,d2
	move.w	d1,d2
	add.l	d2,d2
	move.w	(a5,d2.l),d0	*c
	bmi	@f
	move.b	d0,(a3)+	*wptr
	bra	?394
@@
	cmp.w	#255,d5		*MaxColor
	ble	@f
	pea	?C1(OPC)
	jbsr	_error
	addq.w	#4,sp
@@
	move.w	d5,(a5,d2.l)	*colormap
	move.b	d5,(a3)+	*wptr

	move.w	d1,d0
	lsl.w	#3,d0
	and.w	#$f8,d0
	btst	#3,d0
	beq	@f
	or.w	#7,d0
@@
	move.w	d0,(a2,d4.w)	*Blue

	lsr.w	#2,d1
	move.w	d1,d0
	and.w	#$f8,d0
	btst	#3,d0
	beq	@f
	or.w	#7,d0
@@
	move.w	d0,(a0,d4.w)	*Red

	lsr.w	#5,d1
	and.w	#$f8,d1
	btst	#3,d1
	beq	@f
	or.w	#7,d1
@@
	move.w	d1,(a1,d4.w)	*Green

	addq.w	#2,d4
	addq.w	#1,d5
?394:
	dbra	d3,?402
	clr.w	d3
	subq.l	#1,d3
	bpl	?402

	move.l	a5,-(sp)	*colormap
	DOS	_di_mfree
	addq.w	#4,sp

	move.l	d5,_MaxColorGuaranteed

	movem.l	(sp)+,d3/d4/d5/a3/a4/a5
	rts

	.even
_t2w:
	move.l	d3,-(sp)
	movea.l	8(sp),a2	*src
	movea.l	a2,a0		*rptr
	movea.l	a2,a1		*wptr
	move.l	12(sp),d3	*size
	lsr.l	#1,d3		*size / 2
	moveq.l	#$f8,d2
	bra	?408
?410:
	move.b	(a0)+,d1	*r
	move.b	(a0)+,d0	*g
	lsl.w	#5,d0
	move.b	d1,d0
	add.w	d0,d0
	add.w	d0,d0
	and.w	d2,d0
	move.b	(a0)+,d1	*b
	lsr.b	#3,d1
	or.b	d1,d0
	move.w	d0,(a1)+
?408:
	dbra	d3,?410
	clr.w	d3
	subq.l	#1,d3
	bpl	?410

	move.l	d3,-(sp)	*size / 2
	move.l	a2,-(sp)	*src
	DOS	_di_setblock
	addq.w	#8,sp

	move.l	(sp)+,d3
	rts

	.even
_t2b:
	link	a6,#-2048
	movem.l	d3/d4/d5/d6/a3/a4/a5,-(sp)
	movea.l	8(a6),a4	*rptr= src
	movea.l	a4,a3		*wptr
	moveq.l	#0,d4		*MaxColor

	lea.l	-2048(a6),a1	*palet
	movea.l	a1,a5
	addq.w	#2,a1
	lea.l	-512(a6),a2	*colormap
	movea.l	a2,a0
	move.w	#256-1,d1
	moveq.l	#-1,d0
@@
	move.w	d0,(a0)+
	move.w	d0,(a1)
	addq.w	#6,a1
	dbra	d1,@b

	movea.l	a5,a1
	move.l	12(a6),d2	*size
	lsr.l	#1,d2		*size / 2
	bra	?418
?428:
	clr.w	d0
	move.b	(a4)+,d0	*r
	move.w	d0,d5
	move.b	(a4)+,d6	*g
	lsl.w	#8,d6
	move.b	(a4)+,d6	*b

	add.w	d0,d0
	lea.l	(a2,d0.w),a0
	move.w	(a0),d3		*colormap[r]
	bpl	?423

	move.w	d4,(a0)
	bra	?435
?423:
	move.w	d3,d0
	add.w	d0,d0
	add.w	d3,d0
	add.w	d0,d0
	lea.l	(a1,d0.w),a0
	cmp.w	(a0)+,d6	*palet[c].gb == gb ?
	bne	@f
	move.b	d3,(a3)+	*wptr++= c
	bra	?418
@@
	move.w	(a0),d3	v	*palet[c].next
	bpl	?423

	move.w	d4,(a0)		*palet[c].next= MaxColor
?435:
	cmp.l	#255,d4
	ble	@f
	pea	?C1(OPC)
	jbsr	_error
	addq.w	#4,sp
@@
	move.w	d6,(a5)		*palet[MaxColor].gb= gb
	addq.w	#4,a5
	move.w	d5,(a5)+	*palet.[MaxColor].r= r
	move.b	d4,(a3)+	*wptr++= MaxColor
	addq.w	#1,d4
?418:
	dbra	d2,?428
	clr.w	d2
	subq.l	#1,d2
	bpl	?428

	move.l	8(a6),d1
	move.l	12(a6),d0
	lsr.l	#1,d0
	move.l	d0,-(sp)
	move.l	d1,-(sp)
	DOS	_di_setblock
	addq.w	#8,sp

	move.l	d4,_MaxColorGuaranteed
	lea.l	_Blue,a3
	lea.l	_Green,a2
	lea.l	_Red,a1
	lea.l	-2048(a6),a0
	bra	?431
?434:
	move.w	(a0),d1
	move.w	d1,d0
	lsr.w	#8,d0
	move.w	d0,(a2)+
	move.b	d1,d0
	move.w	d0,(a3)+
	addq.w	#4,a0
	move.w	(a0)+,(a1)+
?431:
	dbra	d4,?434

	movem.l	(sp)+,d3/d4/d5/d6/a3/a4/a5
	unlk	a6
	rts

	.even
_cc8:
	link	a6,#-2048
	movem.l	d3/d4/d5/a3/a4/a5,-(sp)
	move.l	8(a6),d4	*src
	move.l	12(a6),d5	*size
	moveq.l	#0,d3
	move.l	d4,a2
	move.l	d3,d2
	move.l	d3,d1
	lea.l	-2048(a6),a1	*colormap
	movea.l	a1,a0
	move.w	#256-1,d2
	moveq.l	#-1,d0
@@
	move.w	d0,(a0)
	addq.w	#8,a0
	dbra	d2,@b

	move.w	#1,_InBpp
	move.l	d5,d2
	lsr.l	#1,d2		*size / 2
	lea.l	_Red,a5
	lea.l	_Green,a4
	lea.l	_Blue,a3
	bra	cc8lp_ent
cc8_lp:
	move.w	(a2)+,d1	*c
	move.w	d1,d0
	lsl.w	#3,d0
	lea.l	(a6,d0.w),a0
	lea.l	-2048(a0),a0
	tst.w	(a0)
	bpl	cc8lp_ent
	move.w	d3,(a0)
	add.w	d1,d1
	addq.w	#2,a1
	move.w	(a5,d1.w),(a1)+
	move.w	(a4,d1.w),(a1)+
	move.w	(a3,d1.w),(a1)+
	addq.w	#1,d3
cc8lp_ent:
	dbra	d2,cc8_lp
	clr.w	d2
	subq.l	#1,d2
	bpl	cc8_lp

	cmp.l	_MaxColorGuaranteed,d3
	bne	?446
	move.l	d5,-(sp)
	move.l	d4,-(sp)
	bsr	_b2b
	addq.w	#8,sp
	bra	cc8_exit
?446:
	move.l	d4,a1
	move.l	a1,a2
	move.l	d5,d2
	lsr.l	#1,d2
	moveq.l	#0,d1
	lea.l	-2047(a6),a0
	bra	?449
?451:
	move.w	(a2)+,d1
	lsl.w	#3,d1
	move.b	(a0,d1.w),(a1)+
?449:
	dbra	d2,?451
	clr.w	d2
	subq.l	#1,d2
	bpl	?451

	moveq.l	#256-1,d2
	subq.w	#1,a0
?456:
	move.w	(a0),d0
	bmi	?454
	add.w	d0,d0
	move.w	2(a0),(a5,d0.w)
	move.w	4(a0),(a4,d0.w)
	move.w	6(a0),(a3,d0.w)
?454:
	addq.w	#8,a0
	dbra	d2,?456

	lsr.l	#1,d5
	move.l	d5,-(sp)
	move.l	d4,-(sp)
	DOS	_di_setblock
	addq.w	#8,sp

	move.l	d3,_MaxColorGuaranteed
cc8_exit:
	movem.l	(sp)+,d3/d4/d5/a3/a4/a5
	unlk	a6
	rts

	.even
_cc15:
	movem.l	d3/d4/d5/d6/a3/a4,-(sp)
	move.l	28(sp),d5	*src
	move.l	32(sp),d4	*size
	moveq.l	#0,d3		*MaxColor

	move.l	#65536,-(sp)
	DOS	_di_malloc
	addq.w	#4,sp
	tst.l	d0
	bpl	?459

	pea	?C0(OPC)
	bsr	_error
	addq.w	#4,sp
?459:
	move.l	d5,a3		*rptr
	movea.l	d0,a4
	movea.l	d0,a0
	move.l	#32768/8-1,d1
	moveq.l	#-1,d0
?463:
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	dbra	d1,?463

	lea.l	_Red,a0
	lea.l	_Green,a1
	lea.l	_Blue,a2

	lsr.l	#1,d4
	move.l	d4,d1
	moveq.l	#$f8,d2
	bra	?465
?473:
	move.w	(a3)+,d6
	moveq.l	#0,d0
	move.w	d6,d0
	add.l	d0,d0
	tst.w	(a4,d0.l)
	bpl	?465

	cmp.w	#255,d3
	ble	@f

	move.l	a4,-(sp)
	DOS	_di_mfree
	addq.w	#4,sp
	bra	?457
@@
	move.w	d3,(a4,d0.l)

	move.w	d6,d0
	lsl.w	#3,d0
	and.w	d2,d0
	btst	#3,d0
	beq	@f
	or.w	#7,d0
@@
	move.w	d0,(a2)+

	lsr.w	#2,d6
	move.w	d6,d0
	and.w	d2,d0
	btst	#3,d0
	beq	@f
	or.w	#7,d0
@@
	move.w	d0,(a0)+

	lsr.w	#5,d6
	and.w	d2,d6
	btst	#3,d6
	beq	@f
	or.w	#7,d6
@@
	move.w	d6,(a1)+

	addq.w	#1,d3
?465:
	dbra	d1,?473
	clr.w	d1
	subq.l	#1,d1
	bpl	?473

	movea.l	d5,a3
	movea.l	d5,a0
	move.l	d4,d1
	bra	?475
?477:
	moveq.l	#0,d0
	move.w	(a3)+,d0
	add.l	d0,d0
	move.b	1(a4,d0.l),(a0)+
?475:
	dbra	d1,?477
	clr.w	d1
	subq.l	#1,d1
	bpl	?477

	move.l	a4,-(sp)
	DOS	_di_mfree
	addq.w	#4,sp

	move.l	d3,_MaxColorGuaranteed
	move.w	#1,_InBpp
?457:
	movem.l	(sp)+,d3/d4/d5/d6/a3/a4
	rts

	.even
_cc24:
	link	a6,#-2048
	movem.l	d3/d4/d5/d6/d7/a3/a4/a5,-(sp)
	move.l	8(a6),a4	*src
	move.l	12(a6),d7	*size
	moveq.l	#0,d5		*MaxColor
	lea.l	-2048(a6),a5
	movea.l	a5,a1
	addq.w	#2,a1
	lea.l	-512(a6),a2
	movea.l	a2,a0
	move.w	#256-1,d1
	moveq.l	#-1,d0
?485:
	move.w	d0,(a0)+
	move.w	d0,(a1)
	addq.w	#6,a1
	dbra	d1,?485

	movea.l	a5,a3
	move.l	a4,a1		*rptr
	lsr.l	#1,d7		*size / 2
	move.l	d7,d4
	bra	?487
?497:
	clr.w	d6
	move.b	(a1)+,d6	*r
	move.b	(a1)+,d3	*g
	lsl.w	#8,d3
	move.b	(a1)+,d3	*b
	move.w	d6,d0
	add.w	d0,d0
	lea.l	(a2,d0.w),a0
	move.w	(a0),d2
	bpl	?492

	move.w	d5,(a0)
	bra	?511
?492:
	move.w	d2,d0
	add.w	d0,d0
	add.w	d2,d0
	add.w	d0,d0
	lea.l	(a3,d0.w),a0
	cmp.w	(a0)+,d3
	beq	?487

	move.w	(a0),d2
	bpl	?492

	move.w	d5,(a0)
?511:
	cmp.l	#255,d5
	ble	@f

	move.l	#16777216,_MaxColorGuaranteed
	move.w	#4,_InBpp
	bra	?481
@@
	move.w	d3,(a5)
	addq.w	#4,a5
	move.w	d6,(a5)+
	addq.w	#1,d5
?487:
	dbra	d4,?497
	clr.w	d4
	subq.l	#1,d4
	bpl	?497

	move.l	a4,a1		*rptr
	move.l	a4,a5		*wptr
	move.l	d7,d4
	clr.w	d6
	bra	?499
?504:
	move.b	(a1)+,d6	*r
	move.b	(a1)+,d3	*g
	lsl.w	#8,d3
	move.b	(a1)+,d3	*b
	add.w	d6,d6
	move.w	(a2,d6.w),d2	*c= colormap[r]
	bra	?501
?503:
	move.w	(a0),d2		*c= palet[c].next
?501:
	move.w	d2,d0
	add.w	d0,d0
	add.w	d2,d0
	add.w	d0,d0
	lea.l	(a3,d0.w),a0	*palet[c].gb
	cmp.w	(a0)+,d3
	bne	?503

	move.b	d2,(a5)+
?499:
	dbra	d4,?504
	clr.w	d4
	subq.l	#1,d4
	bpl	?504

	move.l	d7,-(sp)
	move.l	a4,-(sp)
	DOS	_di_setblock
	addq.w	#8,sp

	move.l	d5,_MaxColorGuaranteed
	lea.l	_Blue,a2
	lea.l	_Green,a1
	lea.l	_Red,a0
	bra	?507
?510:
	move.w	(a3),d1
	addq.w	#4,a0
	move.w	d1,d0
	lsr.w	#8,d0
	move.w	d0,(a1)+	*g
	move.b	d1,d0
	move.w	d0,(a2)+	*b
	move.w	(a3)+,(a0)+	*r
?507:
	dbra	d5,?510

	move.w	#1,_InBpp
?481:
	movem.l	(sp)+,d3/d4/d5/d6/d7/a3/a4/a5
	unlk	a6
	rts

	.even
	.globl _ColorManager
_ColorManager:
	move.l	_Size,-(sp)
	move.l	_Screen,-(sp)
	move.w	_OutBpp,d1
	move.w	_InBpp,d0
	cmp.w	#1,d1
	bne	?514
	cmp.w	#2,d0
	bne	@f
	bsr	_w2b
	bra	?531
@@
	btst	#2,d0
	beq	@f
	bsr	_t2b
	bra	?531
@@
	btst	#6,d0
	bne	?531
	bsr	_b2b
?531:
	move.w	#1,_InBpp
	bra	?520

?514:
	cmp.w	#2,d1
	bne	?521
	cmp.w	#1,d0
	bne	@f
	bsr	_b2w
	bra	?523
@@
	btst	#2,d0
	beq	?523
	bsr	_t2w
?523:
	move.w	#2,_InBpp
	bra	?520

?521:
	tst.b	d1
	bpl	?520
	cmp.w	#1,d0
	bne	@f
	bsr	_cc8
	bra	?520
@@
	cmp.w	#2,d0
	bne	@f
	bsr	_cc15
	bra	?520
@@
	bsr	_cc24
?520:
	addq.w	#8,sp
	rts

	.even
	.end
